; ****************************************************
; : Riniy
;     :  12.08.16                                   
;  : 8 MHz RC                           
; ****************************************************

; RGB   WS2812
;   , ,   .

/*.device		ATmega8a
.nolist
.include	"m8def.inc"
.list
*/
; =====================
; 
; =====================

; WS2812 (RGB  GRB)
;#define	RGB
#define	GRB


.equ	NPRG 	=	56 		;.   ( 8)

.equ	white	=	1		; 
.equ	blue	=	2
.equ	red		=	3
.equ	orange	=	4
.equ	green	=	5
.equ	cyan	=	6
.equ	magenta	=	7
.equ	yellow	=	8

;=========  =================
.def	NULL	= r2
.def	FULL	= r3

.def	temp	=	r16
.def	temp1	=	r17
.def	temp2	=	r18
.def	temp3	=	r21

.def	Flags	=	r20		; 	0b -  -
							;		1b - Save_Buffer_WS_AddrCHK   RGB ,    _RNDColor8
							;		2b -   _Multiplier = YH
							;		3b -   _Lowspeed	= YL
							;		4b -  -  _Sector = XL
							;		5b -        
							;		6b - 
							;		7b - 
;r22  Random

;=========    =================
;PortB
.equ	WSout	=	1	;
.equ	TESTout	=	5	;

;PortD
.equ	Buttn	=	2	;
.equ	Led30	=	6	;
.equ	Led40	=	5	;
.equ	Ledinit	=	7	;

;PortC

;==================================================
; 
	.DSEG
_test:	 .byte 3
_BuffLED:		.byte	150			;LEDS*3	; GRB  ( 0x73)
FlgPRG:			.byte	NPRG/8		;   (     )
_Progr:			.byte	1			;  ( )
_HSV:			.byte	1			;
_Color0:		.byte	1			;  (  1...8)
_Color1:		.byte	3			;  ( )
_Color2:		.byte	3			; 
_Sector:		.byte	1			;-   
_Section:		.byte	1			;-   
_Lowspeed:		.byte	1			;   ( )
_LoopPRG:		.byte	1			;-   
_Multiplier:	.byte	1			;   ( )
_RepeatPRG:		.byte	1			;    
_VBuffCURR:		.byte	2			;   
_RND:			.byte	1			;   
_RNDColor8:		.byte	9			;     (1...8) + 1  
_a:				.byte	1			; 
_LEDS:			.byte	5			;-    (0-  - -, 1-  *3, 23 LEDS*3+BUFFLED, 4-   )

.CSEG
	.ORG 	0x0000
	RJMP 	Reset	
	.ORG	INT0addr		;  INT0		(  0
	RETI
	.ORG	INT1addr		;  INT1		(  1)
	RETI
	.ORG	OC2addr			;   T/C2 COMP	(  / T/C2)
	RETI
	.ORG	OVF2addr		;  T/C2 OVF	(  / T/C2)
	RETI
	.ORG	ICP1addr		;  T/C1 CAPT	(  / T/C1)
	RETI
	.ORG	OC1Aaddr		;  TIMER1 COMPA		( ""  / T/C1)
	RETI
	.ORG	OC1Baddr		;  TIMER1 COMPB		( "B"  / T/C1)
	RETI
	.ORG	OVF1addr		;  T/C1 OVF	(  / T/C1)
	RETI
	.ORG	OVF0addr		;  T/C0 OVF	(  / T/C0)
	RETI
	.ORG	SPIaddr			;  SPI, STC	(  SPI )
	RETI
	.ORG	URXCaddr		;  USART RXC	(  USART )
	RETI
	.ORG	UDREaddr		;  USART UDRE	(  USART )
	RETI
	.ORG	UTXCaddr		;  USART TXC	(  USART )
	RETI
	.ORG	ADCCaddr		;  ADC		(  )
	RETI
	.ORG	ERDYaddr		;  EE READY	(EEPROM )
	RETI
	.ORG	ACIaddr			;  ANA COMP	(   )
	RETI
	.ORG	TWIaddr			;  TWI		(   TWI)
	RETI
	.ORG	SPMRaddr		;  SPM READY	( SPM)
	RETI
.ORG	INT_VECTORS_SIZE		;   

;==============================================================================
;
Reset:
	ldi temp,low(RAMEND)
	out SPL,temp
	ldi temp,High(RAMEND)
	out	SPH,temp

; 
	clr	ZH						;  (256)
	ldi	ZL,0xFF					;
	ReadData:					;
	ld	temp,-Z					;
	add rnd_b,temp
	cpi ZL,0x1F
	brne	ReadData			;/
	sbr rnd_b,1					; 
	push rnd_b					; 

;  
	clr	ZH						;
	ldi	ZL,0x1d					;
	RgClr:						;
	st	Z,ZH					;
	dec	ZL						;
	brne	RgClr				;/

	pop rnd_b					;   

;  
	ldi	ZL,Low(SRAM_START)		;  ( 200 ),    
	ldi	temp,200				;
	st	Z+,r3					;
  	dec	temp					;
	brne PC-2					;/

	com r3						;   FULL
	sbi	ACSR,ACD				;   

; /
	ldi temp,(1<<PB0|0<<WSout|1<<PB2|1<<PB3|1<<PB4|0<<TESTout|1<<PB6|1<<PB7)
	out PORTB,temp
	ldi temp,(1<<WSout|1<<TESTout)
	out	DDRB,temp

	ldi temp,(1<<PD0|1<<PD1|1<<Buttn|1<<PD3|1<<PD4|1<<Led30|1<<Led40|0<<Ledinit)	;48 (Auto)
;	ldi temp,(1<<PD0|1<<PD1|1<<Buttn|1<<PD3|1<<PD4|1<<Led30|1<<Led40|0<<Ledinit)	;48
;	ldi temp,(1<<PD0|1<<PD1|1<<Buttn|1<<PD3|1<<PD4|1<<Led30|0<<Led40|0<<Ledinit)	;39
;	ldi temp,(1<<PD0|1<<PD1|1<<Buttn|1<<PD3|1<<PD4|0<<Led30|1<<Led40|0<<Ledinit)	;30
	out PORTD,temp

	ldi temp,(0<<PD0|0<<PD1|0<<Buttn|0<<PD3|0<<PD4|0<<Led30|0<<Led40|1<<Ledinit)	;48 (Auto)
;	ldi temp,(0<<PD0|0<<PD1|0<<Buttn|0<<PD3|0<<PD4|1<<Led30|1<<Led40|1<<Ledinit)	;48
;	ldi temp,(0<<PD0|0<<PD1|0<<Buttn|0<<PD3|0<<PD4|0<<Led30|1<<Led40|1<<Ledinit)	;39
;	ldi temp,(0<<PD0|0<<PD1|0<<Buttn|0<<PD3|0<<PD4|1<<Led30|0<<Led40|1<<Ledinit)	;30
	out	DDRD,temp

	out PORTC,full
	out DDRC,null

; -     
	ldi temp,48
	sbis PIND,Led40				;  39 
	ldi temp,39
	sbis PIND,Led30				;  30 
	ldi temp,30
	rcall Save_LEDS_RAM
	
	ldi temp,0x3D
	sbis PIND,Led40				;  39 
	ldi temp,0x49
	sbis PIND,Led30				;  30 
	ldi temp,0x58
	sts _LEDS+4,temp			; 

;  TC2/1024
;        0.2 (0x01), 0.5 (0x03), 1 (0x07), 2 (0x0F), 4 (0x1E), 8 (0x3D), 16 (0x7C)  32 (0xF9) mSec
	ldi temp,0x3D
	out OCR2,temp

	out TCNT2,null
	ldi temp,(1<<WGM21|0<<WGM20|1<<CS22|1<<CS21|1<<CS20)
	out TCCR2,temp	


; Watchdog 2 sec
WDR
in r16, WDTCR
ori r16, (1<<WDCE)|(1<<WDE)
out WDTCR, r16
ldi r16, (1<<WDP2|1<<WDP1|0<<WDP0|1<<WDE)
out WDTCR, r16


;==============================================================================
; 
;    ,   ,     .

;   
mn_Clear_flagsPRG:
		ldi	ZH,high(FlgPRG)
		ldi	ZL,low(FlgPRG)
	mn_Clr_flgs_loop:
		st	Z+,null
		cpi	ZL,low(FlgPRG+(NPRG/8))
		brne mn_Clr_flgs_loop

		ldi	temp,NPRG				; 
	mn_Loop_run_prg:
		sts	_Progr,temp
	mn_Loop_return:
;   
		ldi temp,NPRG				; 
		rcall Random
		rcall Modulo
;ldi temp,7
		ldi	ZL,low(table_prog*2-2)	;      
		ldi	ZH,High(table_prog*2-2)
		lsl temp
		add	ZL,temp			 		;    
		adc	ZH,null
		lpm	temp,Z+					; 
		lpm	temp1,Z
		movw ZH:ZL,temp1:temp		;  Z
		ijmp						;

	mn_Check_END:
		ldi temp,0x3D				; 
		out OCR2,temp

		lds	temp,_Progr				;    
		dec	temp
		brne mn_Loop_run_prg		;,  
;rjmp pc
		rjmp	mn_Clear_flagsPRG	;,  

;==============================================================================
;
;==============================================================================


;==============================================================================
;
;==============================================================================

.include	"HSVtoRGB_lib.asm"
.include	"DataRandom.asm"
.include	"Random.asm"
.include	"programms.asm"
.include	"WS2812_lib.asm"
.include	"div8u.asm"

;===================================================
; -    (0-  - -, 1-  *3, 23 LEDS*3+BUFFLED)
Save_LEDS_RAM:
	sts _LEDS,temp				;- 
	ldi temp1,3
	mul	temp,temp1
	sts _LEDS+1,r0				;- *3
	ldi	YL,low(_BuffLED)
	ldi	YH,High(_BuffLED)
	add YL,r0
	adc YH,r1
	sts _LEDS+2,YH				;- *3+BUFF
	sts _LEDS+3,YL
ret

;===================================================
; WSsend   (  128 )
WSsend_WaitLowspeed:
		rcall WSsend
;  
;  temp  temp1
WaitLowspeed:
		lds temp1,_Lowspeed
;ldi temp1,1
	WaitLowspeed_01:
		in temp,TIFR
		sbrs temp,OCF2					; 
		rjmp PC-2
		ldi temp,(1<<OCF2)
		out	TIFR,temp
		out TCNT2,null
		dec	temp1						;  
		brne WaitLowspeed_01

		lds	temp,_LoopPRG				;   
		dec	temp
		sts _LoopPRG,temp
wdr
ret

;===================================================
;  (  500   64 )
;  temp
Dec_Multiplier:
		lds	temp,_Multiplier
		dec temp
		sts _Multiplier,temp
ret

;===================================================
;   
Dec_Repeat:
		lds	temp,_RepeatPRG
		dec temp
		sts _RepeatPRG,temp
ret

;===================================================
;     - LED  
Speed_correction:
		lds YL,_LEDS+4				; 
		out OCR2,YL
ret


;===================================================
; LEDS*3    Y (_BuffLED+LEDS*3)
Leds3_Y:
		lds YH,_LEDS+2
		lds YL,_LEDS+3
ret

; LEDS*3/2    Y (_BuffLED+(LEDS/2)*3)
Leds3_lsr2_Y:
		lds YL,_LEDS
		lsr YL
		adc YL,null					;  ,  1
;sbc YL,null
		ldi YH,3
		mul YL,YH					; r0= *3
		ldi YL,low(_BuffLED)
		ldi YH,High(_BuffLED)
		add YL,r0
		adc YH,null

/*		lds r0,_LEDS+1
		lsr r0
		adc r0,null					;  ,  1
		ldi YL,low(_BuffLED)
		ldi YH,High(_BuffLED)
		add YL,r0
		adc YH,null*/
ret

; Y   Y+LEDS*3-temp
Check_Leds3_Y_temp:
		push ZL
		push ZH

		lds ZH,_LEDS+2
		lds ZL,_LEDS+3
		sub ZL,temp
		sbc ZH,null

		cp	YL,ZL					;   
		cpc YH,ZH

		pop ZH
		pop ZL
ret

;===================================================
; RGB 
Clear_RGB:
		mov	rgb_r,null
		mov	rgb_g,null
		mov	rgb_b,null
ret

; RGB   Color
Color1_RGB:
		sts _Color1,rgb_r
		sts _Color1+1,rgb_g
		sts _Color1+2,rgb_b
ret

Color2_RGB:
		sts _Color2,rgb_r
		sts _Color2+1,rgb_g
		sts _Color2+2,rgb_b
ret

Color2_NULL:
		sts _Color2,NULL
		sts _Color2+1,NULL
		sts _Color2+2,NULL
ret

;===================================================
;   Color  RGB
RGB_Color1:
		lds	rgb_r,_Color1
		lds	rgb_g,_Color1+1
		lds	rgb_b,_Color1+2
ret

RGB_Color2:
		lds	rgb_r,_Color2
		lds	rgb_g,_Color2+1
		lds	rgb_b,_Color2+2
ret

;===================================================
;   
;temp =  
;Z =  
Change_Hue_Z_HSV:
		ldi ZL,low(_HSV)
		ldi ZH,high(_HSV)
Change_Hue:
		brts Change_Hue01			; 
		com temp
		inc temp
	Change_Hue01:
		ld	HSV_H,Z
		add	HSV_H,temp
		st	Z,HSV_H
ret

;===================================================
;         _Color0
Background_Color8_Down:
		lds temp,_RNDColor8
Background_Color_Down:
		push temp
		ldi temp,64					; 
		mov HSV_V,temp
		lds temp,_Color0			;   
		rcall LoadColor
		mov temp2,temp
		pop temp
		cp temp,temp2
		brne Background_Color_Down00
		rcall Clear_RGB				; ,  
		mov HSV_V,full				; ,  
	Background_Color_Down00:
		rcall Color1_RGB			;  
		rcall LoadColor				; 
		rcall HSV_2_RGB
		rcall Color2_RGB
ret

;===================================================
;      RGB   
Shift_BufferWS:
		brts Shift_BufferWS_Back
		rcall Leds3_Y						;    
		sbiw Y,3
	ShiftWS00:
		ld temp,-Y
		std Y+3,temp
		ldi	temp,High(_BuffLED)
		cpi YL,low(_BuffLED)
		cpc YH,temp
		brne ShiftWS00
		ldi temp,1
		rcall Save_Buffer_WS_Addr
ret
	Shift_BufferWS_Back:
		ldi	YL,low(_BuffLED+3)				;    
		ldi	YH,High(_BuffLED+3)
	ShiftWS01:
		ld temp,Y
		sbiw Y,3
		st Y,temp
		adiw Y,4
		clr temp
		rcall Check_Leds3_Y_temp			;  (_BuffLED+LEDS*3+0)
		brne ShiftWS01
		sbiw Y,3
		ldi temp,1
		rcall Save_Buffer_WS_Addr
ret

;===================================================
;    _Color2
Save_Buffer_WS_background_Y_Color2:
		ldi YL,low(_Color2)
		ldi YH,High(_Color2)
;    (  rgb)
Save_Buffer_WS_background:
		ld rgb_r,Y+
		ld rgb_g,Y+
		ld rgb_b,Y
;   GRB  ( rgb)
Save_Buffer_WS:
		ldi YL,low(_BuffLED)		;  
		ldi YH,High(_BuffLED)
		lds temp,_LEDS				; 
;   ( rgb)
Save_Buffer_WS_Addr:
		Save_Buff_loop:
		st	Y+,rgb_r
		st	Y+,rgb_g
		st	Y+,rgb_b
		dec	temp
		brne Save_Buff_loop
ret

;===================================================
;    GRB     . 
/*Y -  , T - , _Sector - , _Section - -   , LEDS -  

j100    Y	(Y - , temp=_Sector)
Y + _Section
Y>_BuffLED+LEDS*3
 j100
 
*/
Save_Buffer_Sector:
		lds YH,_VBuffCURR				;   Y	(Y - , temp=_Sector)
		lds YL,_VBuffCURR+1
		push YH
		push YL
Save_Buffer_Sector00:
		rcall Save_Buffer_WS_AddrCHK_Sector
		sbiw Y,3						; Y
		brtc PC+2
		adiw Y,6
		rcall Shift_Y_Section			; Y  _Section

		ldi	temp,High(_BuffLED)
		cpi	YL,low(_BuffLED)			;   
		cpc YH,temp
		brlo Save_Buffer_SectorExt		;  -  

		ldi temp,2
		rcall Check_Leds3_Y_temp		;    (_BuffLED+LEDS*3-2)
		brsh Save_Buffer_SectorExt		;    -  
		rjmp Save_Buffer_Sector00
Save_Buffer_SectorExt:
		pop YL
		pop YH
		rcall Save_Buff_YShift			; Y  
ret

;===================================================
;    GRB   .    _RNDColor8 ( 1)      ( 5)
;temp -   
;Y -   
;X -   _RNDColor8 ( )
Save_Buffer_WS_AddrCHK_SectorY:
		lds YH,_VBuffCURR
		lds YL,_VBuffCURR+1
Save_Buffer_WS_AddrCHK_Sector:
		lds	temp,_Sector
Save_Buffer_WS_AddrCHK:
	Save_Buff_loop01:
		ldi	temp1,High(_BuffLED)
		cpi	YL,low(_BuffLED)		;   
		cpc YH,temp1
		brlo Save_Buff_loop02		;  -  
		push temp
		ldi temp,2
		rcall Check_Leds3_Y_temp		;    (_BuffLED+LEDS*3-2)
		pop temp
		brsh Save_Buff_loop02		;    -  

		;  ,  RGB    _RNDColor8
		sbrs flags,1
		rjmp Save_Buff_rgb
		push temp
		ld temp,X
		rcall LoadColor
		pop temp

	Save_Buff_rgb:
		sbrs flags,5				;   
		rjmp Save_Buff_rgb_save
		ld temp1,Y					; ,   
		add temp1,rgb_r				;
		brcc Save_Buff_sum_g
		ser temp1
		Save_Buff_sum_g:
		st	Y,temp1
		ldd temp1,Y+1				;
		add temp1,rgb_g
		brcc Save_Buff_sum_b
		ser temp1
		Save_Buff_sum_b:
		std	Y+1,temp1
		ldd temp1,Y+2				;
		add temp1,rgb_b
		brcc PC+2
		ser temp1
		std	Y+2,temp1
		rjmp Save_Buff_loop02

	Save_Buff_rgb_save:
		st	Y,rgb_r
		std	Y+1,rgb_g
		std	Y+2,rgb_b

		Save_Buff_loop02:
		sbrc flags,1				;   _RNDColor8
		adiw X,1					; ,   
		adiw Y,3
		brtc PC+2					; 
		sbiw Y,6

		dec	temp
		brne Save_Buff_loop01

		lds YH,_VBuffCURR			;  
		lds YL,_VBuffCURR+1
Save_Buff_YShift:
		adiw Y,3					;  
		brtc PC+2
		sbiw Y,6
		sts _VBuffCURR,YH
		sts _VBuffCURR+1,YL
ret

;===================================================
; RGB      temp,  HSV  
LoadColor:
		ldi ZL,4
		mul ZL,temp
		ldi	ZL, low(table_color*2-4)	;      
		ldi	ZH, High(table_color*2-4)
		add	ZL,r0				 		;     
		adc	ZH,r1
		lpm	rgb_r,Z+					;   3 
		lpm	rgb_g,Z+
		lpm	rgb_b,Z+
		lpm	HSV_H,Z						; (  4- )
Check_WhiteHSV:
		mov HSV_S,full					;,    = 255,  = 0
		cpi temp,White					;  
		brne PC+2
		clr HSV_S		
ret

;==============================================
; 
InvertT:
		bld temp,0
		eor temp,full
		bst temp,0
ret

;==============================================
;  -     -        
;-       ,  -   -  
;_Section=(LEDS-1+_Sector)/_Sector
;temp1 = _Sector (- )
Section_calc:
		lds temp,_LEDS					;=LEDS-1
		dec temp
		add temp,temp1					;(LEDS-1+_Sector)
		rcall div8u						;/_Sector
		sts _Section,temp				;
ret

;==============================================
;   Y  -   
Shift_Y_Section:
		lds temp,_Section				;Y + _Section
		ldi temp1,3
		mul temp1,temp
		brts Shift_Y_1
		add YL,r0
		adc YH,r1
		rjmp Shift_Y_0
	Shift_Y_1:
		sub YL,r0
		sbc YH,r1
	Shift_Y_0:
rcall Addr_Vbuffer_done
;		sts _VBuffCURR,YH
;		sts _VBuffCURR+1,YL
ret

;==============================================
;       -   
;   ,    
Addr_VbufferSectorYL1:
		ldi YL,1
		rjmp Addr_VbufferSectorYL
Addr_Vbuffer:
		lds YL,_Sector
Addr_VbufferSectorYL:
		ldi temp,3
		mul YL,temp
		lds temp,_LEDS					;   = (LEDS - 1 + )
		dec temp
		add YL,temp
		sts _LoopPRG,YL

		brts Addr_Vbuffer_back			;      
		; = ( )
		ldi YL,low(_BuffLED+3)
		ldi YH,High(_BuffLED+3)
		sub YL,r0
		sbc YH,r1
		rjmp Addr_Vbuffer_done

		; = ( )
	Addr_Vbuffer_back:
		rcall Leds3_Y
		sbiw Y,6
		add YL,r0
		adc YH,r1
	Addr_Vbuffer_done:
		sts _VBuffCURR,YH
		sts _VBuffCURR+1,YL
ret

;==============================================
;  ()   
Rnd_On_Off_LED:
		rcall Clear_RGB
		brts Rnd_On_Off_00
		rcall RGB_Color1
	Rnd_On_Off_00:
		lds temp,_LEDS					; 
		rcall Random
		rcall Modulo
		dec temp
		ldi temp1,3
		mul temp,temp1
		mov temp,r0
		ldi YH,High(_BuffLED)			;,      ?  ,   
		ldi YL,low(_BuffLED)
		add YL,r0
		adc YH,r1

		ld temp,Y
		cp temp,null
		ldd temp,Y+1
		cpc temp,null
		ldd temp,Y+2
		cpc temp,null
		brtc Rnd_On_Off_01
		breq Rnd_On_Off_00
		rjmp Rnd_On_Off_Ext
	Rnd_On_Off_01:
		brne Rnd_On_Off_00
	Rnd_On_Off_Ext:
ret

;==============================================
; 2    _RNDColor8     
Mix_Color:
		rcall RND_load_Color		; 2  ( )
		ldi temp1,2
		ldi	YL,low(_RNDColor8)
		ldi	YH,high(_RNDColor8)
	Mix_Color_01:
		ld temp,Y+
		cpi temp,white
		breq Mix_Color_01
		rcall LoadColor
		dec temp1
		breq Mix_Color_02
		rcall Color2_RGB
		cpi temp1,1
		breq Mix_Color_01
		rjmp Mix_Color_03
	Mix_Color_02:
		rcall Color1_RGB
	Mix_Color_03:
		mov temp,rgb_r
		mov XL,rgb_g
		mov XH,rgb_b
		rcall RGB_Color2
		add rgb_r,temp				; 2 
		breq PC+2
		mov rgb_r,full
		add rgb_g,XL
		adc rgb_g,null
		breq PC+2
		mov rgb_g,full		
		add rgb_b,XH
		breq PC+2
		mov rgb_b,full

		ldi XL,low(_Color1)			;  
		ldi XH,high(_Color1)
		ldi temp1,1					;   Color1
		rcall Check_RGB_Null
		cp temp,rgb_r
		rcall Check_RGB_Null
		cpc temp,rgb_g
		rcall Check_RGB_Null
		cpc temp,rgb_b
		breq Mix_Color_01			; ,  Color1
		ldi temp1,3					;   Color2
		rcall Check_RGB_Null
		cp temp,rgb_r
		rcall Check_RGB_Null
		cpc temp,rgb_g
		rcall Check_RGB_Null
		cpc temp,rgb_b
		breq Mix_Color_01			; ,  Color2
ret
	Check_RGB_Null:					; ,   ,    (     )
		ld temp,X+
		cpse temp,null
		mov temp,full
ret

;==============================================
;  HSV_V     T
;      _a   (1 byte)
Change_Bright:
		brts Change_BrightDown			;   ?
		cp HSV_V,full					;   
		breq Change_BrightExt
		cp HSV_V,null
		brne Change_BrightUp
		ldi temp,128
		sts _Lowspeed,temp				; 
		ldi temp,1
		sts _a,temp
	Change_BrightUp:
		inc HSV_V
		cp HSV_V,full					;   
		breq Change_BrightExt
		lds temp,_a
		cp HSV_V,temp
		brne Change_BrightExt
		lds temp1,_Lowspeed
		cpi temp1,1
		breq PC+2
		lsr temp1
		lsl temp
		brcc Change_BrightSave
		ser temp
		rjmp Change_BrightSave
/*
=1
 = 255
 + 1,  255 - 
 = ?  - 

 /2
a=a*2
 
*/
	Change_BrightDown:
		cp HSV_V,null					;   
		breq Change_BrightExt
		cp HSV_V,full
		brne Change_BrightDn01
		ldi temp,128					; 
		sts _a,temp
	Change_BrightDn01:
		dec HSV_V
		cp HSV_V,null					;   
		breq Change_BrightExt
		lds temp,_a
		cp HSV_V,temp
		brne Change_BrightExt
		lds temp1,_Lowspeed
		lsr temp
		brcc PC+2
		ldi temp,128		
		cpi temp1,128
		breq Change_BrightSave
		lsl temp1
		brcc Change_BrightSave
		ser temp1
/*
=128
 = 1
 - 1,  0 - 
 = ?  - 

 *2
a=a/2
 
*/
	Change_BrightSave:
		sts _Lowspeed,temp1
		sts _a,temp
	Change_BrightExt:
ret

;===========    ============
table_prog: 
.dw		PRG01, PRG02, PRG03, PRG04, PRG05, PRG06, PRG07, PRG08, PRG09, PRG10, PRG11
.dw		PRG12, PRG13, PRG14, PRG15, PRG16, PRG17, PRG18, PRG19, PRG20, PRG21, PRG22
.dw		PRG23, PRG24, PRG25, PRG26, PRG27, PRG28, PRG29, PRG30, PRG31, PRG32, PRG33
.dw		PRG34, PRG35, PRG36, PRG37, PRG38, PRG39, PRG40, PRG41, PRG42, PRG43, PRG44
.dw		PRG45, PRG46, PRG47, PRG48, PRG49, PRG50, PRG51, PRG52, PRG53, PRG54, PRG55
.dw		PRG56, PRG57, PRG58, PRG59, PRG60, PRG61, PRG62, PRG63, PRG64

;===========    ============
table_color: ;(RGB)+HAVR

#ifdef RGB
.db		0xE0,0xFF,0xFF,255	,0x00,0x00,0xFF,171		; 			
.db		0xFF,0x00,0x00,0	,0xFF,0x40,0x00,11		; 		
.db		0x00,0xFF,0x00,85	,0x00,0xFF,0xFF,129		; 		
.db		0xFF,0x00,0xFF,214	,0xFF,0xC0,0x00,32		; 		
#endif

#ifdef GRB
.db		0xFF,0xE0,0xFF,255	,0x00,0x00,0xFF,171		; 			
.db		0x00,0xFF,0x00,85	,0x40,0xFF,0x00,74		; 		
.db		0xFF,0x00,0x00,0	,0xFF,0x00,0xFF,214		; 		
.db		0x00,0xFF,0xFF,129	,0xC0,0xFF,0x00,53		; 		
#endif
